$Chip  ORG #5B00

CHIP   DI
       LD   A,(#4000)
       OUT  (#00),A
       LD   HL,#2E4D
       LD   (#8438),HL
       LD   L,#4B
       LD   (#843A),HL
       LD   IX,#8014
       LD   B,#1F
       SUB  A
DOP_I1 LD   H,(IX+#16)
       LD   L,(IX+#17); hl=len
       LD   D,(IX+#1C)
       LD   E,(IX+#1D); de=loop len
       AND  A
       SBC  HL,DE
       LD   D,(IX+#1A)
       LD   E,(IX+#1B); de=start loop
       AND  A
       SBC  HL,DE
       JR   NC,DOP_I2
       AND  A
       JP   NZ,ChipSP+3 ;l5CAE
       SRL  (IX+#1A)
       RR   (IX+#1B)
       INC  A
       JR   DOP_I1
DOP_I2 LD   DE,#001E
       ADD  IX,DE
       DJNZ DOP_I1-1

       LD   DE,#043C

       LD   A,(#419E)
       LD   L,A
       LD   H,B
       ADD  HL,HL
       ADD  HL,HL
       LD   A,H
       LD   H,L
       LD   L,B
       ADD  HL,DE
       ADC  A,B

       LD   (CHIPLN),HL
       LD   (CHIPLN+2),A
       LD   (ChipSP+1),SP
       LD   HL,CHIPLN
       LD   DE,CHIPPP
       PUSH DE
       LDI
       LDI
       LDI
       POP  IY
       LD   B,#1F
       LD   DE,#001E
       LD   IX,#8014
ChIp   LD   H,(IX+#16)
       LD   L,(IX+#17)
       CALL TOCip
       ADD  IX,DE
       DJNZ ChIp

       LD   IX,#802A
       LD   B,#1F
CHIP1  DI
       LD   A,(#4000)
       OUT  (#00),A
       LD   H,(IX+#06)
       LD   L,(IX+#07)
       LD   (CHIP2+1),HL
       LD   A,(IX+#00)
       OR   (IX+#01)
       JP   Z,CHIP2
       LD   DE,#0002
       CALL CP_DDE
       JP   C,CHIP2
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
LUPLEN LD   DE,#0200
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       CALL CP_DDE
       JP   NC,CHIP2
       PUSH BC
       LD   (CHIP4+1),HL
       LD   (CHIP6+1),HL
       LD   B,H
       LD   C,L
       EXX
       LD   BC,#0000
CHIP3  EXX
       ADD  HL,BC
       CALL CP_DDE
       EXX
       INC  BC
       JR   C,CHIP3
       PUSH BC
       EXX

;!!!!!!!!!!!!!!!!!!!!!!!!!!
       PUSH HL
       LD   B,(IX+#06)
       LD   C,(IX+#07)
       AND  A
       SBC  HL,BC

       LD   DE,CHIPPP
       LD   (TOcip+1),DE
       LD   IY,CIP1
       CALL TOCIP
       LD   DE,CHIPLN
       LD   (TOcip+1),DE

       LD   B,#03
       LD   DE,CIP1+2
       LD   HL,MEMAGS+2
ChipLP LD   A,(DE)
       CP   (HL)
       DEC  HL
       DEC  DE
       JR   C,ChipOK
       JP   NZ,ChipSP
       DJNZ ChipLP
ChipOK POP  HL

       EX   DE,HL
       LD   H,(IX+#00)
       LD   L,(IX+#01)
       LD   B,(IX+#06)
       LD   C,(IX+#07)
       AND  A
       SBC  HL,BC
       ADD  HL,DE
       LD   (IX+#00),H
       LD   (IX+#01),L
       LD   (IX+#06),D
       LD   (IX+#07),E
       LD   IY,CIP1
       LD   H,(IX+#04)
       LD   L,(IX+#05)
       PUSH HL
       PUSH HL
       PUSH HL
       ADD  HL,BC
       CALL TOCIP
       LD   IY,CIP2
       POP  HL
       ADD  HL,DE
       CALL TOCIP
       LD   HL,CHIPPP
       LD   DE,CIP3
       LDI
       LDI
       LDI
       CALL DIRER
       LD   IY,CIP1
       POP  HL
       CALL TOCIP
       POP  HL
CHIP4  LD   DE,#0000
       ADD  HL,DE
       LD   IY,CIP2
       CALL TOCIP
       LD   HL,CIP2
       LD   DE,CIP3
       LDI
       LDI
       LDI
       POP  BC
CHIP5  PUSH BC
       CALL DIRER
CHIP6  LD   HL,#0000
       LD   IY,CIP2
       CALL ADD_IY-3
       POP  BC
       DEC  BC
       LD   A,B
       OR   C
       JR   NZ,CHIP5
       POP  BC
CHIP2  LD   DE,#0000
       LD   A,(#4000)
       OUT  (#00),A
       LD   H,(IX+#06)
       LD   L,(IX+#07)
       AND  A
       SBC  HL,DE
       LD   IY,CHIPPP
       CALL TOCip
       LD   H,(IX+#00)
       LD   L,(IX+#01)
       LD   IY,CHIPLN
       CALL TOCip
       LD   DE,#001E
       ADD  IX,DE
       DEC  B
       JP   NZ,CHIP1
ChipSP LD   SP,#0000
       LD   A,#FF
       LD   (#40B7),A
       CALL #0D1F
       EI
       JP   #026B

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
CHIPLN DEFB #00,#00,#00; 4 
CHIPPP DEFB #00,#00,#00;  
MEMAGS DEFB #33,#44,#55;   GS

CIP1   DEFB #00,#00,#00;  
CIP2   DEFB #00,#00,#00;  
CIP3   DEFB #00,#00,#00;  
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

DIRER  LD   IY,CIP1
       LD   L,(IY+#03)
       LD   H,(IY+#04)
       LD   B,(IY+#05)
       EXX
       LD   L,(IY+#00)
       LD   H,(IY+#01)
       LD   B,(IY+#02)
       LD   E,(IY+#06)
       LD   D,(IY+#07)
       LD   C,(IY+#08)
       PUSH IX
       CALL RESI10
       POP  IX
       RET
TOCIP  PUSH HL
       PUSH DE
       PUSH IY
       POP  DE
TOcip  LD   HL,CHIPLN
       LDI
       LDI
       LDI
       POP  DE
       POP  HL
TOCip  CALL ADD_IY
ADD_IY LD   A,(IY+#00)
       ADD  A,L
       LD   (IY+#00),A
       LD   A,(IY+#01)
       ADC  A,H
       LD   (IY+#01),A
       LD   A,(IY+#02)
       ADC  A,#00
       LD   (IY+#02),A
       RET

CP_DDE PUSH HL
       AND  A
       SBC  HL,DE
       POP  HL
       RET

RESI10 SUB  A
       OUT  (#00),A
       LD   (#4082),A
       LD   A,B
       PUSH HL
       EXX
       POP  DE
       PUSH HL
       PUSH BC
       LD   C,A
       OR   A
       SBC  HL,DE
       LD   A,B
       SBC  A,C
       EX   DE,HL
       POP  BC
       POP  HL
       LD   C,A
       OR   E
       OR   D
       RET  Z
       EXX
       EX   DE,HL
       SBC  HL,DE
       LD   A,C
       SBC  A,B

       DEFB #DD ;prefix for LD IXl,A
       LD   L,A

       OR   L
       OR   H
       EXX
       RET  Z
       PUSH DE
       PUSH BC
       BIT  7,C
       EXX
       JP   NZ,#CC2B
       JP   #CCCD
